unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, DB, ADODB, Grids, DBGrids;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    edtPassword: TEdit;
    edtServerName: TEdit;
    edtUserName: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    GroupBox1: TGroupBox;
    Label4: TLabel;
    edtDatabaseFile: TEdit;
    SpeedButton1: TSpeedButton;
    Label5: TLabel;
    edtDatabaseName: TEdit;
    Button3: TButton;
    GroupBox2: TGroupBox;
    DBGrid1: TDBGrid;
    Button4: TButton;
    ADOConnection1: TADOConnection;
    ADOQuery1: TADOQuery;
    ADOCommand1: TADOCommand;
    DataSource1: TDataSource;
    OpenDialog1: TOpenDialog;
    SpeedButton2: TSpeedButton;
    edtLogFile: TEdit;
    Label6: TLabel;
    Button5: TButton;
    Label7: TLabel;
    procedure ADOConnection1AfterConnect(Sender: TObject);
    procedure ADOConnection1AfterDisconnect(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    function ConnectToDB:Boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.ADOConnection1AfterConnect(Sender: TObject);
begin
  Button1.Enabled:=False;
  Button2.Enabled:=True;
  Button3.Enabled:=True;
  Button4.Enabled:=True;
  Button5.Enabled:=True;
  ADOQuery1.SQL.Text:='select name from sys.databases order by name';
  ADOQuery1.Open;
end;

procedure TForm1.ADOConnection1AfterDisconnect(Sender: TObject);
begin
  Button1.Enabled:=True;
  Button2.Enabled:=False;
  Button3.Enabled:=False;
  Button4.Enabled:=False;
  Button5.Enabled:=True;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if not ConnectToDB then
    ShowMessage('Can''t connect to server');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ADOConnection1.Close;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if edtDatabaseFile.Text=EmptyStr then
    begin
      ShowMessage('select database file');
      Exit;
    end;
  if not FileExists(edtDatabaseFile.Text) then
    begin
      ShowMessage('select database name');
      Exit;
    end;
  ADOCommand1.CommandText:='If Not(exists(Select name from sysdatabases where name='+QuotedStr(edtDatabaseName.Text)+')) ';
  if not FileExists(edtLogFile.Text) then
    ADOCommand1.CommandText:=ADOCommand1.CommandText+'EXEC sp_attach_single_file_db @dbname = '+QuotedStr(edtDatabaseName.Text)+',@physname = '+QuotedStr(edtDatabaseFile.Text)
  else
    ADOCommand1.CommandText:=ADOCommand1.CommandText+'EXEC sp_attach_db @dbname = '+QuotedStr(edtDatabaseName.Text)+',@filename1 = '+QuotedStr(edtDatabaseFile.Text)+',@filename2 = '+QuotedStr(edtLogFile.Text);
  ADOCommand1.Execute;
  ADOQuery1.Requery;
  ADOQuery1.Locate('name',edtDatabaseName.Text,[]);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  if ADOQuery1.RecordCount>0 then
    begin
      ADOCommand1.CommandText:='EXEC sp_detach_db '+QuotedStr(ADOQuery1.Fields.Fields[0].AsString);
      ADOCommand1.Execute;
      ADOQuery1.Requery;
    end;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  ADOQuery1.Requery;
end;

function TForm1.ConnectToDB:Boolean;
begin
  Result:=True;
  with ADOConnection1 do
    begin
      Close;
      if edtUserName.Text=EmptyStr then
        ConnectionString:='Provider=SQLOLEDB.1;Integrated Security=SSPI;Persist Security Info=False;Data Source='+edtServerName.Text
      else
      if edtPassword.Text=EmptyStr then
        ConnectionString:='Provider=SQLOLEDB.1;Persist Security Info=False;User ID='+edtUserName.Text+';Data Source='+edtServerName.Text
      else
        ConnectionString:='Provider=SQLOLEDB.1;Password='+edtPassword.Text+';Persist Security Info=True;User ID='+edtUserName.Text+';Data Source='+edtServerName.Text;
      try
        Open;
      except
        Result:=False;
      end;
    end;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  ADOConnection1.Close;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  OpenDialog1.Filter:='SQL Server Database (*.mdf)|*.mdf';
  if DirectoryExists(ExtractFileDir(edtDatabaseFile.Text)) then
    OpenDialog1.InitialDir:=ExtractFileDir(edtDatabaseFile.Text);
  if OpenDialog1.Execute(Handle) then
    begin
      edtDatabaseFile.Text:=OpenDialog1.FileName;
      if edtDatabaseName.Text=EmptyStr then
        edtDatabaseName.Text:=ChangeFileExt(ExtractFileName(edtDatabaseFile.Text),'');
    end;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  OpenDialog1.Filter:='SQL Server Log (*.ldf)|*.ldf';
  if OpenDialog1.Execute(Handle) then
    edtLogFile.Text:=OpenDialog1.FileName;
end;

end.
